//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

#include <stdio.h>
#include <windows.h>
#include <wincrypt.h>
#include <time.h>
#include "randomGen.h"

HCRYPTPROV		ghProvider = 0;


//************************************************************************************
// Initializes the crypto context
//
//************************************************************************************

BOOL initRand()
{
	srand(time(NULL));
	return CryptAcquireContext(&ghProvider, 0, 0, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT);
}


//************************************************************************************
// Returns a DWORD random number
//
//************************************************************************************

DWORD getRandDWORD(void)
{
	DWORD result;

	/* The CryptoAPI returns sizeof(buf) bytes of randomness */
	if(ghProvider)
	{
		
		if (CryptGenRandom(ghProvider, sizeof(DWORD), (BYTE *)&result))
		{
			return result;
		}
	}
	
	return (((DWORD)rand()) << 16) | (DWORD)rand();
}


//************************************************************************************
// Returns a WORD random number
//
//************************************************************************************

WORD getRandWORD(void)
{
	/* The CryptoAPI returns sizeof(buf) bytes of randomness */
	if(ghProvider)
	{
		WORD result;
		if (CryptGenRandom(ghProvider, sizeof(WORD), (BYTE *)&result))
		{
			return result;
		}
	}
	
	return rand();
}


//************************************************************************************
// Returns a buffer of random bytes
//
//************************************************************************************

void getRandBytes(unsigned char *buffer, int size)
{
	if(ghProvider)
	{
		if (CryptGenRandom(ghProvider, size, (BYTE *)buffer))
		{
			return;
		}
	}
	for(int i = 0; i < size; i++)
	{
		buffer[i] = rand() % 256;
	}
}
